/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.138 by edhill, Sun Dec 4 13:57:08 2005 UTC revision 1.161 by jmc, Sun Feb 18 21:39:59 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 282  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 321  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 535  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 545  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 698  EOF Line 769  EOF
769    
770    
771  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
772        if test ! "x$HAVE_SIGREG" = x ; then
773            return
774        fi
775      get_fortran_c_namemangling      get_fortran_c_namemangling
776      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
777  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 755  EOF Line 829  EOF
829    
830    
831  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
832        if test "x$HAVE_SETRLSTK" = xt ; then
833            DEFINES="$DEFINES -DHAVE_SETRLSTK"
834            return
835        fi  
836        if test ! "x$HAVE_SETRLSTK" = x ; then
837            return
838        fi
839      get_fortran_c_namemangling      get_fortran_c_namemangling
840      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
841  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 865  EOF Line 946  EOF
946      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
947      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
948      RET_CPP=f      RET_CPP=f
949      COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
950      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
951      $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t      eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
952      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
953          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
954              >> genmake_tnc.log              >> genmake_tnc.log
# Line 875  EOF Line 956  EOF
956              >> genmake_tnc.log              >> genmake_tnc.log
957      fi      fi
958      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
959      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
960      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
961          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
962      RET_COMPILE=$?      RET_COMPILE=$?
963      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> genmake_warnings
964    
# Line 893  EOF Line 974  EOF
974      else      else
975          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
976          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "try again with added '-lnetcdf'" > genmake_tnc.log
977          echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
978          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
979          echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
980          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
981              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
982              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
983          RET_COMPILE=$?          RET_COMPILE=$?
984          cat genmake_tnc.log >> genmake_warnings          cat genmake_tnc.log >> genmake_warnings
985          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
986              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
987              HAVE_NETCDF=t              HAVE_NETCDF=t
988            else
989            # try again with "-lnetcdff" added to the libs
990                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
991                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
992                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
993                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
994                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
995                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
996                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
997                RET_COMPILE=$?
998                cat genmake_tnc.log >> genmake_warnings
999                if test "x$RET_COMPILE" = x0 ; then
1000                    LIBS="$LIBS -lnetcdff -lnetcdf"
1001                    HAVE_NETCDF=t
1002                fi
1003          fi          fi
1004      fi      fi
1005      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 950  NOOPTFLAGS= Line 1046  NOOPTFLAGS=
1046  MPI=  MPI=
1047  MPIPATH=  MPIPATH=
1048  TS=  TS=
1049    PAPIS=
1050    PCLS=
1051    FOOLAD=
1052    PAPI=
1053    PCL=
1054    HPMT=
1055    GSL=
1056    DEVEL=
1057  HAVE_TEST_L=  HAVE_TEST_L=
1058    
1059  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 957  HAVE_SYSTEM= Line 1061  HAVE_SYSTEM=
1061  HAVE_FDATE=  HAVE_FDATE=
1062  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1063  HAVE_CLOC=  HAVE_CLOC=
1064  HAVE_SETRLSTK=  # HAVE_SETRLSTK=
1065  HAVE_STAT=  HAVE_STAT=
1066  HAVE_NETCDF=  HAVE_NETCDF=
1067  HAVE_ETIME=  HAVE_ETIME=
# Line 974  BASH= Line 1078  BASH=
1078  PWD=`pwd`  PWD=`pwd`
1079  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1080  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1081    EMBED_SRC=
1082  THISHOST=`hostname`  THISHOST=`hostname`
1083  THISCWD=`pwd`  THISCWD=`pwd`
1084  THISDATE=`date`  THISDATE=`date`
# Line 1007  TAMC_EXTRA= Line 1112  TAMC_EXTRA=
1112    
1113  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1114  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1115  gm_s2="FC CPP IEEE TS MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1116    
1117  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1118  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 1189  for ac_option in "$@" ; do Line 1294  for ac_option in "$@" ; do
1294    
1295          -ts | --ts)          -ts | --ts)
1296              TS=true ;;              TS=true ;;
1297            -papis | --papis)
1298                PAPIS=true ;;
1299            -pcls | --pcls)
1300                PCLS=true ;;
1301            -foolad | --foolad)
1302                FOOLAD=true ;;
1303            -papi | --papi)
1304                PAPI=true ;;
1305            -pcl | --pcl)
1306                PCL=true ;;
1307            -hpmt | --hpmt)
1308                HPMT=true ;;
1309    
1310            -gsl | --gsl)
1311                GSL=true ;;
1312    
1313            -devel | --devel)
1314                DEVEL=true ;;
1315    
1316          -mpi | --mpi)          -mpi | --mpi)
1317              MPI=true ;;              MPI=true ;;
# Line 1217  for ac_option in "$@" ; do Line 1340  for ac_option in "$@" ; do
1340          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1341              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1342    
1343            -es | --es | -embed-source | --embed-source)
1344                EMBED_SRC=t ;;
1345    
1346          -*)          -*)
1347              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1348              usage              usage
# Line 1235  done Line 1361  done
1361  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1362      echo      echo
1363      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1364      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1365      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1366      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1367      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1368      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1369      echo      echo
1370  fi  fi
1371    
1372  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1373  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1374      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1375      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1376          ROOTDIR=".."          ROOTDIR=".."
1377      else      else
1378          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1432  fi Line 1557  fi
1557    
1558  if test ! "x$TS" = x ; then  if test ! "x$TS" = x ; then
1559        echo "  Turning on timing per timestep"        echo "  Turning on timing per timestep"
1560        DEFINES="$DEFINES -DTIME_PER_TIMESTEP"        if test ! "x$FOOLAD" = x ; then
1561                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1562          else
1563                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1564          fi
1565    fi
1566    if test ! "x$PAPIS" = x ; then
1567          echo "  Turning on PAPI flop summary per timestep"
1568          echo "  Please make sure PAPIINC, PAPILIB are defined"
1569          if test ! "x$FOOLAD" = x ; then
1570                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1571          else
1572                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1573          fi
1574          INCLUDES="$INCLUDES $PAPIINC"
1575          LIBS="$LIBS $PAPILIB"
1576    fi
1577    if test ! "x$PCLS" = x ; then
1578          echo "  Turning on PCL counter summary per timestep"
1579          echo "  Please make sure PCLINC, PCLLIB are defined"
1580          if test ! "x$FOOLAD" = x ; then
1581                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1582          else
1583                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1584          fi
1585          INCLUDES="$INCLUDES $PCLINC"
1586          LIBS="$LIBS $PCLLIB"
1587    fi
1588    if test ! "x$PAPI" = x ; then
1589          if test ! "x$PAPIS" = x ; then
1590              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1591              echo "  Sticking with PAPI flop summary per timestep!"
1592          else
1593              echo "  Turning on performance analysis with PAPI"
1594              echo "  Please make sure PAPIINC, PAPILIB are defined"
1595              DEFINES="$DEFINES -DUSE_PAPI"
1596              INCLUDES="$INCLUDES $PAPIINC"
1597              LIBS="$LIBS $PAPILIB"
1598          fi
1599    fi
1600    if test ! "x$PCL" = x ; then
1601          if test ! "x$PCLS" = x ; then
1602              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1603              echo "  Sticking with PCL flop summary per timestep!"
1604          else
1605              echo "  Turning on performance analysis with PCL"
1606              echo "  Please make sure PCLINC, PCLLIB are defined"
1607              DEFINES="$DEFINES -DUSE_PCL"
1608              INCLUDES="$INCLUDES $PCLINC"
1609              LIBS="$LIBS $PCLLIB"
1610          fi
1611    fi
1612    if test ! "x$HPMT" = x ; then
1613          if test ! "x$PAPI" = x ; then
1614              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1615              echo "  Sticking with PAPI!"
1616          else if test ! "x$PCL" = x ; then
1617              echo "  PCL and the HPM Toolkit cannot co-exist!"
1618              echo "  Sticking with PCL!"
1619          else
1620              echo "  Turning on performance analysis with the HPM Toolkit"
1621              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1622              DEFINES="$DEFINES -DUSE_LIBHPM"
1623              INCLUDES="$INCLUDES $HPMTINC"
1624              LIBS="$LIBS $HPMTLIB"
1625          fi
1626          fi
1627    fi
1628    if test ! "x$GSL" = x ; then
1629          echo "  Turning on use of GSL to control floating point calculations"
1630          echo "  Please make sure GSLINC, GSLLIB are defined"
1631          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1632          INCLUDES="$INCLUDES $GSLINC"
1633          LIBS="$LIBS $GSLLIB"
1634  fi  fi
1635    
1636  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 1503  if test "x$HAVE_CLOC" != x ; then Line 1701  if test "x$HAVE_CLOC" != x ; then
1701      echo "yes"      echo "yes"
1702  else  else
1703      echo "no"      echo "no"
1704        if test "x$EMBED_SRC" = xt ; then
1705            echo "    WARNING: you requested file embedding but it has"
1706            echo "      been disabled since C code cannot be called"
1707            EMBED_SRC=
1708        fi
1709  fi  fi
1710  rm -f genmake_t*  rm -f genmake_t*
1711    
1712  printf "  Can we unlimit the stack size using $FC...  "  printf "  Can we unlimit the stack size using $FC...  "
1713  check_HAVE_SETRLSTK  check_HAVE_SETRLSTK
1714  if test "x$HAVE_SETRLSTK" != x ; then  if test "x$HAVE_SETRLSTK" = xt ; then
1715      echo "yes"      echo "yes"
1716  else  else
1717      echo "no"      echo "no"
# Line 1517  rm -f genmake_t* Line 1720  rm -f genmake_t*
1720    
1721  printf "  Can we register a signal handler using $FC...  "  printf "  Can we register a signal handler using $FC...  "
1722  check_HAVE_SIGREG  check_HAVE_SIGREG
1723  if test "x$HAVE_SIGREG" != x ; then  if test "x$HAVE_SIGREG" = xt ; then
1724      echo "yes"      echo "yes"
1725  else  else
1726      echo "no"      echo "no"
# Line 1542  else Line 1745  else
1745  fi  fi
1746  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1747    
1748    if test "x$EMBED_SRC" = xt ; then
1749        build_embed_encode
1750    fi
1751    if test "x$EMBED_SRC" = xt ; then
1752        ENABLE="$ENABLE embed_files"
1753    fi
1754    
1755    
1756  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1757  printf "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1758  for d in $MODS ; do  for d in $MODS ; do
# Line 1627  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1838  if test -r $ROOTDIR"/eesupp/src/Makefile
1838      fi      fi
1839  fi  fi
1840    
1841  #same for exch2  #same for pkg/exch2 and pkg/regrid
1842  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1843      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1844      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1845      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1846      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1847          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1848      else              rm -f make_${pdir}.errors
1849          echo "Error: problem encountered while building source files in exch2:"          else
1850          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1851          exit 1              cat make_${pdir}.errors 1>&2
1852                exit 1
1853            fi
1854      fi      fi
1855  fi  done
1856    
1857  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1858  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1750  done Line 1963  done
1963  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1964  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1965    
1966  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1967  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1968  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1969  RETVAL=$?  RETVAL=$?
1970  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1785  EOF Line 1998  EOF
1998      fi      fi
1999  fi  fi
2000    
2001    #  Check for package PROFILES: if NetCDF is not available,
2002    #  then delete profiles from the list of available packages.
2003    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2004    RETVAL=$?
2005    if test "x$RETVAL" = x0 ; then
2006        if test "x$HAVE_NETCDF" != xt ; then
2007            cat <<EOF
2008    
2009    *********************************************************************
2010    WARNING: the "profiles" package was enabled but tests failed to
2011      compile NetCDF applications.  Please check that:
2012    
2013      1) NetCDF is correctly installed for this compiler and
2014      2) the LIBS variable (within the "optfile") specifies the correct
2015           NetCDF library to link against.
2016    
2017      Due to this failure, the "profiles" package is now DISABLED.
2018    *********************************************************************
2019    
2020    EOF
2021            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2022            DISABLE="$DISABLE profiles"
2023        fi
2024    fi
2025    
2026  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2027  ck=  ck=
2028  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 1993  for i in $INCLUDEDIRS ; do Line 2231  for i in $INCLUDEDIRS ; do
2231      fi      fi
2232  done  done
2233    
2234    if test ! "x$DIVA" = x ; then
2235        echo "  Creating the pseudo-MPI include directory"
2236        INCLUDES="-I./mpi_headers $INCLUDES"
2237        rm -rf ./mpi_headers
2238        mkdir -p ./mpi_headers
2239    
2240        if test "x$MPIINCLUDEDIR" = x ; then
2241            if test "x$MPIHOME" = x ; then
2242                MPIHOME='/usr'
2243            fi
2244            MPIINCLUDEDIR='$MPIHOME/include'
2245        fi
2246        
2247        if test -r $MPIINCLUDEDIR/mpif.h ; then
2248            for i in $MPI_HEADER_FILES; do
2249                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2250            done
2251    
2252            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2253        else
2254            echo " We cannot create a copy of mpif.h!"
2255    #       exit -1
2256        fi
2257    fi
2258    
2259  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2260  rm -rf .links.tmp  rm -rf .links.tmp
2261  mkdir .links.tmp  mkdir .links.tmp
2262    touch .links.tmp/foo
2263    if test ! -r ".links.tmp/foo" ; then
2264        echo
2265        echo "ERROR : something is wrong with your directory permissions or"
2266        echo "   your user file-creation mask (\"umask\") since creating a"
2267        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2268        echo "   not working.  Please try setting your umask to something"
2269        echo "   sane such as:"
2270        echo
2271        echo "      umask 0002"
2272        echo
2273        echo "   and please verify that you have the proper permissions for"
2274        echo "   creating sub-directories and then reading files created"
2275        echo "   within them."
2276        echo
2277        exit 1
2278    fi
2279    rm -f .links.tmp/foo
2280  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2281  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2282  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 2014  for d in $alldirs ; do Line 2295  for d in $alldirs ; do
2295                  ignore_f=f                  ignore_f=f
2296                  case $d/$sf in                  case $d/$sf in
2297                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2298                            ignore_f=t
2299                          ;;                          ;;
2300                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2301                            ignore_f=t
2302                          ;;                          ;;
2303                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2304                            ignore_f=t
2305                          ;;                          ;;
2306                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2307                            ignore_f=t
2308                            ;;
2309                      ./EMBEDDED_FILES.h)
2310                            ignore_f=t
2311                          ;;                          ;;
2312                    *)                    *)
2313                          #  For the local directory *ONLY*,                          #  For the local directory *ONLY*,
# Line 2132  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2420  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2420    
2421  # These files are created by Makefile  # These files are created by Makefile
2422  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2423  EOF  EOF
2424    
2425  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2426        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2427    else
2428        echo "EMBEDDED_FILES = " >>$MAKEFILE
2429    fi
2430    
2431    #  Note: figure out some way to add Hyades JAM libraries here
2432  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2433  # Unix ln (link)  # Unix ln (link)
2434  LN = ${LN}  LN = ${LN}
# Line 2198  rm -f ad_flow_files.inc Line 2490  rm -f ad_flow_files.inc
2490  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2491    
2492  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2493  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2494          @echo Creating \$@ ...          @echo Creating \$@ ...
2495          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2496  depend:  depend:
# Line 2211  lib: libmitgcmuv.a Line 2503  lib: libmitgcmuv.a
2503    
2504  libmitgcmuv.a: \$(OBJFILES)  libmitgcmuv.a: \$(OBJFILES)
2505          ar rcv libmitgcmuv.a \$(OBJFILES)          ar rcv libmitgcmuv.a \$(OBJFILES)
2506            ar d   libmitgcmuv.a main.o
2507    
2508  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2509    
# Line 2221  output.txt: \$(EXECUTABLE) Line 2514  output.txt: \$(EXECUTABLE)
2514          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2515    
2516  clean:  clean:
2517          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2518            -rm -rf *.o
2519            -rm -rf *.$FS
2520  Clean:  Clean:
2521          @make clean          @make clean
2522          @make cleanlinks          @make cleanlinks
# Line 2232  CLEAN: Line 2527  CLEAN:
2527          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2528          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2529          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2530          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2531            -rm -rf mnc_test_*
2532    
2533  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2534  makefile:  makefile:
# Line 2260  test ! "x$THISUSER" = x && echo "      -echo Line 2556  test ! "x$THISUSER" = x && echo "      -echo
2556  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2557  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2558    
2559    if test "x$EMBED_SRC" = xt ; then
2560        cat >>$MAKEFILE <<EOF
2561    
2562    decode_files.o : EMBEDDED_FILES.h
2563    
2564    ##  \$(F77FILES)
2565    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2566            @echo Creating \$@ ...
2567            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2568            -rm -f all_fF.tar.gz
2569            -gzip all_fF.tar
2570    
2571    EMBEDDED_FILES.h : all_fF.tar.gz
2572            @echo Creating \$@ ...
2573            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2574    
2575    EOF
2576    fi
2577    
2578  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2579    
2580  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2271  cat >>$MAKEFILE <<EOF Line 2586  cat >>$MAKEFILE <<EOF
2586          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2587  .$FS.o:  .$FS.o:
2588          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2589  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2590          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2591  .c.o:  .c.o:
2592          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2593    
2594  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2595  .F.p:  .F.p:
# Line 2300  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2613  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2613  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2614  for i in $ad_vars ; do  for i in $ad_vars ; do
2615      name=$i      name=$i
2616      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2617      eval $t1      eval $t1
2618      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2619      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2620  done  done
2621    
2622  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2320  rm -f ad_files Line 2633  rm -f ad_files
2633  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2634    
2635  # ... AD ...  # ... AD ...
2636  adall: ad_taf  adall: \$(EXE_AD)
2637  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2638  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2639    
# Line 2340  adtafonly: Line 2653  adtafonly:
2653          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2654          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2655    
2656  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2657          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2658    
2659  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2660          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS

Legend:
Removed from v.1.138  
changed lines
  Added in v.1.161

  ViewVC Help
Powered by ViewVC 1.1.22